#!/usr/bin/perl
# 
# Front end PERL for the freedom remailer.
# Version 1.0
# (First public release)
#
#
# Released under the GNUPL. 
# 
# Credit for this code and the motivation for our server goes to Lance Cottrell
# for the wonderful mixmaster remailer and cypherpunks everywhere.
#
#
# Please send improvements and bug reports to:
# 
# remailer-admin@freedom.gmsociety.org

# Updated by the Chicago admin <xenophon@techmonkeys.net> to include user
# selectable remailers, along with stats displayed with each remailer.

# Wordwrap function wraps the message at char 74.  Change the 74 in the function
# below to reflect what you'd like to wrap at.

# VARIABLES - EDIT THIS!

# location of the mix executable
$mix = "/home/xenophon/Mix/mix";

# END

sub WordWrap {
	$quotedtext = $_[0];
	$returntext = "";
	$length = length($quotedtext)-1;
	$wrapcount = 0;
	foreach $key (0..$length) {
		$char = substr($quotedtext,$key,1);
		$wrapcount++;
		if (($wrapcount > 74) && ($char eq " ")) {
			$char = "\n";
		}
		$returntext = $returntext.$char;
		if ($char =~ /\n/) {
			$wrapcount = 0;
		}
	}
	$returntext =~ s/\n\./\n \./g;
	return $returntext;
}



$| = 1; # turn off buffering

# Print out what we need
print "Content-type: text/html\n\n";

# Get the input
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});

# Split the name-value pairs
@pairs = split(/&/, $buffer);

foreach $pair (@pairs) {
  ($name, $value) = split(/=/, $pair);
  $value =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $val = $value;

  # Uncomment for debugging purposes
  #print "Setting $name to $value<P>\n";

  # filter away potentially nasty meta-characters
  $value =~ s/>//g;
  $value =~ s/\//g;
  $value =~ s/<//g;
  $value =~ s/'//g;
  $value =~ s/"//g;
  $value =~ s/&//g;
  $value =~ s/`//g;
  $value =~ s/\///g;
  $value =~ s/|//g;

  $var{$name} = $value;          # the filtered value for that form element
  $var_unfiltered{$name} = $val; # the unfiltered value for that form element
}
$subject = $var_unfiltered{'subject'};
$newsgroups = $var{'newsgroups'};
$references = $var_unfiltered{'references'};
$from = $var_unfiltered{'from'};
$message = $var_unfiltered{'message'};
$chain = $var{'chain'};
$archive = $var{'archive'};
$remailer1 = $var{'remailer1'};
$remailer2 = $var{'remailer2'};
$remailer3 = $var{'remailer3'};
$remailer4 = $var{'remailer4'};
$remailer5 = $var{'remailer5'};
$remailer6 = $var{'remailer6'};

$message = &WordWrap($message); # do the wordwrap


# no remailer selected..use random
if ("$remailer1" eq "0") {
        $remailer1 = "*";
}
if ("$remailer2" eq "0") { 
        $remailer2 = "*";
}
if ("$remailer3" eq "0") { 
        $remailer3 = "*";
}
if ("$remailer4" eq "0") {
	$remailer4 = "*";
}
if ("$remailer5" eq "0") { 
        $remailer5 = "*";
}
if ("$remailer6" eq "0") { 
        $remailer6 = "*";
}


# random
if ("$remailer1" eq "1") {
        $remailer1 = "*";
}
if ("$remailer2" eq "1") {
        $remailer2 = "*";
}
if ("$remailer3" eq "1") {
        $remailer3 = "*";
}
if ("$remailer4" eq "1") { 
        $remailer4 = "*";
}
if ("$remailer5" eq "1") {
        $remailer5 = "*";
}
if ("$remailer6" eq "1") {
        $remailer6 = "*";
}


# check that all fields are present that are needed to send the message


if ("$subject" eq "") {
  $subject = "(No Subject)";
}

if ("$newsgroups" eq "") {
  push(@errors, "You must specify a newsgroup on the <b>Newsgroup(s):</b> line.");
  $errors++;
}

# do we have any errors?  if so, reparse mixmaster.html to insert error
# message(s) and fill in form values submitted previously
if($errors > 0) {
  open(HTML, "<../newserror.html");
       print "<font size=+1><b>The following error occured:</b></font><p><ul>\n";
      print "<font size=+1 color=#ff0000>\n";
      foreach $error (@errors) {
        print "<li> $error\n";
      }
      print "</font>\n";
      print "</ul>\n";
  while(chop($_ = <HTML>)) {
      print "$_\n";
   }
      exit;
}



# if all fields are there then let's send the message 
if ("$chain" == 2) {
open(MIX, "|$mix -m -l \"$remailer1\",\"$remailer2\"");
}
elsif ("$chain" == 3) {
open(MIX, "|$mix -m -l \"$remailer1\",\"$remailer2\",\"$remailer3\"");
}
elsif ("$chain" == 4) {   
open(MIX, "|$mix -m -l \"$remailer1\",\"$remailer2\",\"$remailer3\",\"$remailer4\"");
}
elsif ("$chain" == 5) {
open(MIX, "|$mix -m -l \"$remailer1\",\"$remailer2\",\"$remailer3\",\"$remailer4\",\"$remailer5\"");
}
elsif ("$chain" == 6) {
open(MIX, "|$mix -m -l \"$remailer1\",\"$remailer2\",\"$remailer3\",\"$remailer4\",\"$remailer5\",\"$remailer6\"");
}
else {
open(MIX, "|$mix -m -l *,*,*");
}

# I'm using 3 mail2news gateways...

print MIX "To: mail2news\@dizum.com,mail2news\@freedom.gmsociety.org,mail2news\@anon.lcs.mit.edu\n";
print MIX "Subject: $subject\n";
print MIX "Newsgroups: $newsgroups\n";
if ("$from" ne "") {
print MIX "From: $from\n";
}
print MIX "References: $references\n";
if ("$archive" == 1) {
	print MIX "X-No-Archive: yes\n";
}
elsif ("$archive" == 0) {
	print MIX "X-No-Archive: no\n";
}
else {
	print MIX "X-No-Archive: yes\n";
}

print MIX "\n";

print MIX "$message\n";
close(MIX);

# I commented the two lines below out because I added a crontab entry to run
# mix -S every 5 minutes.  Saves a little overhead I think...  I had the
# "send" script crontabbed to do this for me.

# open(MIX2, "|$mix -S");
# close(MIX2);



# now give confirmation that it was sent

if ("$chain" == 2) {
$thechain = "Chain: $remailer1,$remailer2";
}
elsif ("$chain" == 3) {
$thechain = "Chain: $remailer1,$remailer2,$remailer3";
}
elsif ("$chain" == 4) {
$thechain = "Chain: $remailer1,$remailer2,$remailer3,$remailer4";
}
elsif ("$chain" == 5) {
$thechain = "Chain: $remailer1,$remailer2,$remailer3,$remailer4,$remailer5";
}
elsif ("$chain" == 6) {
$thechain = "Chain: $remailer1,$remailer2,$remailer3,$remailer4,$remailer5,$remailer6";
}
else {
$thechain = "";
}


print "<html>\n";
print "<head><title>Post Sent</title></head>\n";
print "<body bgcolor=#000000 text=#ffffff>\n";
print "<center><h1>Post Sent. $chain remailers were used.</h1></center>\n";
print "<font size=+1>$thechain</font>\n";
print "<br><br><font size=+1>Thank you for using Chicago's Freedom Remailer.</font>\n";
print "<font size=+1>Click <a href=\"mixnews-user.cgi\">here</a> to go back.</font>\n";
# print "$subject $newsgroups $archive";
print "</body>\n";
print "</html>\n";

# our work here is done...
